/*
 * Distriblend: A distributed rendering system for Blender
 * 
 * Copyright (C) 2007: Ian Philip Thompson
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 */

package net.sf.distriblend.client.gui;

import javax.swing.Icon;

/**
 * A list item holder for use with {@link IconedRenderers}.
 * 
 * @author Ian Thompson
 * 
 */
public class IconedItem {

	/**
	 * 
	 */
	public IconedItem() {
		this(null);
	}

	/**
	 * @param userObject
	 */
	public IconedItem(Object userObject) {
		this(userObject, null);
	}

	/**
	 * @param userObject
	 * @param icon
	 */
	public IconedItem(Object userObject, Icon icon) {
		this.userObject = userObject;
		this.icon = icon;
	}

	/**
	 * @return the userObject
	 */
	public Object getUserObject() {
		return userObject;
	}

	/**
	 * @param userObject
	 *            the userObject to set
	 */
	public void setUserObject(Object userObject) {
		this.userObject = userObject;
	}

	/**
	 * @return the icon
	 */
	public Icon getIcon() {
		return icon;
	}

	/**
	 * @param icon
	 *            the icon to set
	 */
	public void setIcon(Icon icon) {
		this.icon = icon;
	}

	private Object userObject;

	private Icon icon;
}
