/*
 * Distriblend: A distributed rendering system for Blender
 * 
 * Copyright (C) 2007: Ian Philip Thompson
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 */

package net.sf.distriblend.client.gui;

import java.io.File;

import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.ListSelectionModel;


/**
 * @author Ian Thompson
 * 
 */
public class SystemFileList extends JList {

	DefaultListModel model;

	File path = null;

	/**
	 * 
	 */
	public SystemFileList() {
		super();
		model = new DefaultListModel();
		this.setModel(model);
		this.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		this.setCellRenderer(new IconedRenderers.ListCell());
	}

	/**
	 * @param directory
	 */
	public void listDirectory(File directory) {
		this.path = directory;
		int dirCount = 0;
		model.clear();
		if (path.isDirectory()) {
			File[] files = path.listFiles();
			java.util.Arrays.sort(files);
			for (File f : files) {
				/* Add directories to the bottom with files at the top. */
				IconedItem item = new IconedItem(f, Icons.fromFileType(f)
						.getImageIcon());
				if (!f.isDirectory())
					model.add(dirCount++, item);
				else
					model.addElement(item);
			}
		}
	}
}
