/*
 * Distriblend: A distributed rendering system for Blender
 * 
 * Copyright (C) 2007-2008: Ian Philip Thompson
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 */

package net.sf.distriblend.distributor.gui;

import javax.swing.JPanel;

abstract class WizardStep extends JPanel {

	void stepEntered() {
	}

	/**
	 * Validates this step. This method should be called whenever the Next
	 * button is clicked.
	 * 
	 * @return <code>true</code> if the form is valid and the wizard should
	 *         continue to the next step. Otherwise <code>false</code> is
	 *         returned and the wizard should remain at this step.
	 */
	abstract boolean validateForm();
}
