/*
 * Distriblend: A distributed rendering system for Blender
 * 
 * Copyright (C) 2007-2008: Ian Philip Thompson
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 */

package net.sf.distriblend.node.gui;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.io.File;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.border.TitledBorder;

import net.sf.distriblend.share.Settings;

class WizardStep1 extends WizardStep {

	private JTextPane storageRootText = null;

	private JTextPane warningText = null;

	private JTextField storageRootField = null;

	private JButton browseButton = null;

	private JPanel spacerPanel = null;

	private ButtonGroup radioButtonGroup = null;

	private JRadioButton workingDirectoryRadio = null;

	private JRadioButton userHomeRadio = null;

	private JRadioButton customRadio = null;

	private JFileChooser directoryChooser = null;

	/**
	 * This method initializes
	 * 
	 */
	public WizardStep1() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints37 = new GridBagConstraints();
		gridBagConstraints37.gridx = 0;
		gridBagConstraints37.anchor = GridBagConstraints.WEST;
		gridBagConstraints37.insets = new Insets(8, 4, 16, 4);
		gridBagConstraints37.gridwidth = 2;
		gridBagConstraints37.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints37.gridy = 5;
		GridBagConstraints gridBagConstraints36 = new GridBagConstraints();
		gridBagConstraints36.gridx = 0;
		gridBagConstraints36.anchor = GridBagConstraints.WEST;
		gridBagConstraints36.insets = new Insets(0, 16, 4, 16);
		gridBagConstraints36.gridwidth = 2;
		gridBagConstraints36.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints36.gridy = 3;
		GridBagConstraints gridBagConstraints35 = new GridBagConstraints();
		gridBagConstraints35.gridx = 0;
		gridBagConstraints35.anchor = GridBagConstraints.WEST;
		gridBagConstraints35.insets = new Insets(0, 16, 8, 16);
		gridBagConstraints35.gridwidth = 2;
		gridBagConstraints35.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints35.gridy = 2;
		GridBagConstraints gridBagConstraints34 = new GridBagConstraints();
		gridBagConstraints34.gridx = 0;
		gridBagConstraints34.insets = new Insets(8, 16, 0, 16);
		gridBagConstraints34.anchor = GridBagConstraints.WEST;
		gridBagConstraints34.gridwidth = 2;
		gridBagConstraints34.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints34.gridy = 1;
		GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
		gridBagConstraints16.gridx = 0;
		gridBagConstraints16.gridwidth = 2;
		gridBagConstraints16.weightx = 1.0;
		gridBagConstraints16.weighty = 1.0;
		gridBagConstraints16.fill = GridBagConstraints.BOTH;
		gridBagConstraints16.gridy = 6;
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.gridx = 1;
		gridBagConstraints2.insets = new Insets(4, 4, 4, 16);
		gridBagConstraints2.fill = GridBagConstraints.VERTICAL;
		gridBagConstraints2.gridy = 4;
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.fill = GridBagConstraints.BOTH;
		gridBagConstraints1.gridy = 4;
		gridBagConstraints1.weightx = 1.0;
		gridBagConstraints1.insets = new Insets(4, 32, 4, 4);
		gridBagConstraints1.gridwidth = 1;
		gridBagConstraints1.gridx = 0;
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints.gridy = 0;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.weighty = 0.0;
		gridBagConstraints.insets = new Insets(4, 4, 4, 4);
		gridBagConstraints.gridwidth = 2;
		gridBagConstraints.gridx = 0;
		this.setLayout(new GridBagLayout());
		this.setBorder(new TitledBorder(null, "Step 1 of 4",
				TitledBorder.TRAILING, TitledBorder.TOP));
		this.add(getStorageRootText(), gridBagConstraints);
		this.add(getStorageRootField(), gridBagConstraints1);
		this.add(getBrowseButton(), gridBagConstraints2);
		this.add(getSpacerPanel(), gridBagConstraints16);
		this.add(getWorkingDirectoryRadio(), gridBagConstraints34);
		this.add(getUserHomeRadio(), gridBagConstraints35);
		this.add(getCustomRadio(), gridBagConstraints36);
		this.add(getWarningText(), gridBagConstraints37);
	}

	/**
	 * This method initializes storageRootText
	 * 
	 * @return javax.swing.JTextPane
	 */
	private JTextPane getStorageRootText() {
		if (storageRootText == null) {
			storageRootText = new JTextPane();
			storageRootText.setOpaque(false);
			storageRootText.setDisabledTextColor(getStorageRootText()
					.getForeground());
			storageRootText.setEditable(false);
			storageRootText.setText("Important: Please make sure you know the "
					+ "IP address of the distributor before you continue.\n\n"
					+ "Now choose a storage directory for this node. "
					+ "All files sent to this node are stored in this "
					+ "directory (and its sub-directories) until they are "
					+ "finished with.");
		}
		return storageRootText;
	}

	/**
	 * This method initializes storageRootText
	 * 
	 * @return javax.swing.JTextPane
	 */
	private JTextPane getWarningText() {
		if (warningText == null) {
			warningText = new JTextPane();
			warningText.setOpaque(false);
			warningText.setDisabledTextColor(getStorageRootText()
					.getForeground());
			warningText.setEditable(false);
			warningText.setText("WARNING: This directory is periodically "
					+ "purged of all files. Do not set this path to a system "
					+ "directory.");
		}
		return warningText;
	}

	/**
	 * This method initializes storageRootField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getStorageRootField() {
		if (storageRootField == null) {
			storageRootField = new JTextField();
			storageRootField.setText(System.getProperty("user.dir")
					+ File.separator + "storage" + File.separator + "node");
			storageRootField.setEnabled(false);
		}
		return storageRootField;
	}

	/**
	 * This method initializes storageRootBrowseButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBrowseButton() {
		if (browseButton == null) {
			browseButton = new JButton();
			browseButton.setText("Browse...");
			browseButton.setEnabled(false);
			browseButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String path = getStorageRootField().getText();
					getDirectoryChooser().setCurrentDirectory(new File(path));
					int result = getDirectoryChooser().showOpenDialog(
							WizardStep1.this);
					if (result == JFileChooser.APPROVE_OPTION) {
						path = getDirectoryChooser().getSelectedFile()
								.getAbsolutePath();
						getStorageRootField().setText(path);
					}
				}
			});
		}
		return browseButton;
	}

	/**
	 * This method initializes spacerPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getSpacerPanel() {
		if (spacerPanel == null) {
			spacerPanel = new JPanel();
			spacerPanel.setLayout(new GridBagLayout());
		}
		return spacerPanel;
	}

	private ButtonGroup getRadioButtonGroup() {
		if (radioButtonGroup == null) {
			radioButtonGroup = new ButtonGroup();
		}
		return radioButtonGroup;
	}

	/**
	 * This method initializes workingDirectoryRadio
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getWorkingDirectoryRadio() {
		if (workingDirectoryRadio == null) {
			workingDirectoryRadio = new JRadioButton();
			workingDirectoryRadio
					.setText("In the current working directory, within \"storage"
							+ File.separator + "node\"");
			workingDirectoryRadio.setSelected(true);
			workingDirectoryRadio
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							getStorageRootField().setText(
									System.getProperty("user.dir")
											+ File.separator + "storage"
											+ File.separator + "node");
							getStorageRootField().setEnabled(false);
							getBrowseButton().setEnabled(false);
						}
					});
			getRadioButtonGroup().add(workingDirectoryRadio);
		}
		return workingDirectoryRadio;
	}

	/**
	 * This method initializes userHomeRadio
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getUserHomeRadio() {
		if (userHomeRadio == null) {
			userHomeRadio = new JRadioButton();
			userHomeRadio
					.setText("In the current user's home directory, within \".distriblend"
							+ File.separator
							+ "storage"
							+ File.separator
							+ "node\"");
			userHomeRadio
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							getStorageRootField().setText(
									System.getProperty("user.home")
											+ File.separator + ".distriblend"
											+ File.separator + "storage"
											+ File.separator + "node");
							getStorageRootField().setEnabled(false);
							getBrowseButton().setEnabled(false);
						}
					});
			getRadioButtonGroup().add(userHomeRadio);
		}
		return userHomeRadio;
	}

	/**
	 * This method initializes customRadio
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getCustomRadio() {
		if (customRadio == null) {
			customRadio = new JRadioButton();
			customRadio.setText("Choose a directory...");
			customRadio.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					getStorageRootField().setEnabled(true);
					getBrowseButton().setEnabled(true);
				}
			});
			getRadioButtonGroup().add(customRadio);
		}
		return customRadio;
	}

	/**
	 * This method initializes directoryChooser
	 * 
	 * @return javax.swing.JFileChooser
	 */
	private JFileChooser getDirectoryChooser() {
		if (directoryChooser == null) {
			directoryChooser = new JFileChooser();
			directoryChooser
					.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		}
		return directoryChooser;
	}

	private void updateSettings() {
		Settings set = Settings.instance();
		set.setStringProperty("storage.root", getStorageRootField().getText());
	}

	@Override
	boolean validateForm() {
		File storageDir = new File(getStorageRootField().getText());
		if (storageDir.isDirectory()) {
			updateSettings();
			return true;
		}

		int result = JOptionPane.showConfirmDialog(this,
				"The chosen directory does not exist. Create it?",
				"Make Directory?", JOptionPane.YES_NO_CANCEL_OPTION);
		if (result != JOptionPane.YES_OPTION)
			return false;

		if (storageDir.mkdirs()) {
			updateSettings();
			return true;
		}

		JOptionPane.showMessageDialog(this, "Directory "
				+ "could not be created.\nPlease make sure you have write "
				+ "access to this directory or try an alternative.",
				"Make Directory", JOptionPane.ERROR_MESSAGE);
		return false;
	}
}
