/*
 * Distriblend: A distributed rendering system for Blender
 * 
 * Copyright (C) 2007-2008: Ian Philip Thompson
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 */

package net.sf.distriblend.node.gui;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.util.Enumeration;

import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.border.TitledBorder;

import net.sf.distriblend.share.SafeString;
import net.sf.distriblend.share.Settings;

class WizardStep3 extends WizardStep {

	private JPanel spacerPanel = null;

	private JTextPane distributorAddressText = null;

	private JTextPane systemAddressesText = null;

	private JLabel distributorHostLabel = null;

	private JTextField distributorHostField = null;

	private JLabel distributorPortLabel = null;

	private JTextField distributorPortField = null;

	private JLabel distributorUserLabel = null;

	private JTextField distributorUserField = null;

	private JLabel distributorPasswordLabel = null;

	private JPasswordField distributorPasswordField = null;

	private JTextPane distributorLogonText = null;

	/**
	 * This method initializes
	 * 
	 */
	public WizardStep3() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints28 = new GridBagConstraints();
		gridBagConstraints28.fill = GridBagConstraints.BOTH;
		gridBagConstraints28.gridy = 4;
		gridBagConstraints28.weightx = 1.0;
		gridBagConstraints28.weighty = 1.0;
		gridBagConstraints28.gridwidth = 4;
		gridBagConstraints28.weighty = 0.0;
		gridBagConstraints28.insets = new Insets(4, 4, 4, 4);
		gridBagConstraints28.gridx = 0;
		GridBagConstraints gridBagConstraints27 = new GridBagConstraints();
		gridBagConstraints27.fill = GridBagConstraints.BOTH;
		gridBagConstraints27.gridy = 2;
		gridBagConstraints27.weightx = 1.0;
		gridBagConstraints27.weighty = 1.0;
		gridBagConstraints27.gridwidth = 4;
		gridBagConstraints27.weighty = 0.0;
		gridBagConstraints27.insets = new Insets(4, 4, 4, 4);
		gridBagConstraints27.gridx = 0;
		GridBagConstraints gridBagConstraints26 = new GridBagConstraints();
		gridBagConstraints26.fill = GridBagConstraints.BOTH;
		gridBagConstraints26.gridy = 3;
		gridBagConstraints26.weightx = 1.0;
		gridBagConstraints26.insets = new Insets(4, 4, 16, 16);
		gridBagConstraints26.gridx = 3;
		GridBagConstraints gridBagConstraints25 = new GridBagConstraints();
		gridBagConstraints25.gridx = 2;
		gridBagConstraints25.insets = new Insets(4, 16, 16, 4);
		gridBagConstraints25.gridy = 3;
		distributorPasswordLabel = new JLabel();
		distributorPasswordLabel.setText("Password:");
		GridBagConstraints gridBagConstraints24 = new GridBagConstraints();
		gridBagConstraints24.fill = GridBagConstraints.BOTH;
		gridBagConstraints24.gridy = 3;
		gridBagConstraints24.weightx = 1.0;
		gridBagConstraints24.insets = new Insets(4, 4, 16, 4);
		gridBagConstraints24.gridx = 1;
		GridBagConstraints gridBagConstraints23 = new GridBagConstraints();
		gridBagConstraints23.gridx = 0;
		gridBagConstraints23.insets = new Insets(4, 16, 16, 4);
		gridBagConstraints23.gridy = 3;
		distributorUserLabel = new JLabel();
		distributorUserLabel.setText("User:");
		GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
		gridBagConstraints22.fill = GridBagConstraints.BOTH;
		gridBagConstraints22.gridy = 1;
		gridBagConstraints22.weightx = 1.0;
		gridBagConstraints22.insets = new Insets(4, 4, 16, 16);
		gridBagConstraints22.gridx = 3;
		GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
		gridBagConstraints21.gridx = 2;
		gridBagConstraints21.insets = new Insets(4, 16, 16, 4);
		gridBagConstraints21.weightx = 0.0;
		gridBagConstraints21.gridy = 1;
		distributorPortLabel = new JLabel();
		distributorPortLabel.setText("Port:");
		GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
		gridBagConstraints20.fill = GridBagConstraints.BOTH;
		gridBagConstraints20.gridy = 1;
		gridBagConstraints20.weightx = 1.0;
		gridBagConstraints20.insets = new Insets(4, 4, 16, 4);
		gridBagConstraints20.gridx = 1;
		GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
		gridBagConstraints19.gridx = 0;
		gridBagConstraints19.insets = new Insets(4, 16, 16, 4);
		gridBagConstraints19.gridy = 1;
		distributorHostLabel = new JLabel();
		distributorHostLabel.setText("Host:");
		GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
		gridBagConstraints18.fill = GridBagConstraints.BOTH;
		gridBagConstraints18.gridy = 0;
		gridBagConstraints18.weightx = 1.0;
		gridBagConstraints18.weighty = 1.0;
		gridBagConstraints18.gridwidth = 4;
		gridBagConstraints18.weighty = 0.0;
		gridBagConstraints18.insets = new Insets(4, 4, 4, 4);
		gridBagConstraints18.gridx = 0;
		GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
		gridBagConstraints17.gridx = 1;
		gridBagConstraints17.weightx = 1.0;
		gridBagConstraints17.weighty = 1.0;
		gridBagConstraints17.fill = GridBagConstraints.BOTH;
		gridBagConstraints17.gridwidth = 2;
		gridBagConstraints17.gridy = 5;
		this.setLayout(new GridBagLayout());
		this.setBorder(new TitledBorder(null, "Step 3 of 4",
				TitledBorder.TRAILING, TitledBorder.TOP));
		this.add(getSpacerPanel(), gridBagConstraints17);
		this.add(getDistributorAddressText(), gridBagConstraints18);
		this.add(distributorHostLabel, gridBagConstraints19);
		this.add(getDistributorHostField(), gridBagConstraints20);
		this.add(distributorPortLabel, gridBagConstraints21);
		this.add(getDistributorPortField(), gridBagConstraints22);
		this.add(distributorUserLabel, gridBagConstraints23);
		this.add(getDistributorUserField(), gridBagConstraints24);
		this.add(distributorPasswordLabel, gridBagConstraints25);
		this.add(getDistributorPasswordField(), gridBagConstraints26);
		this.add(getDistributorLogonText(), gridBagConstraints27);
		this.add(getSystemAddressesText(), gridBagConstraints28);
	}

	/**
	 * This method initializes spacerPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getSpacerPanel() {
		if (spacerPanel == null) {
			spacerPanel = new JPanel();
			spacerPanel.setLayout(new GridBagLayout());
		}
		return spacerPanel;
	}

	/**
	 * This method initializes distributorAddressText
	 * 
	 * @return javax.swing.JTextPane
	 */
	private JTextPane getDistributorAddressText() {
		if (distributorAddressText == null) {
			distributorAddressText = new JTextPane();
			distributorAddressText.setOpaque(false);
			distributorAddressText
					.setDisabledTextColor(getDistributorAddressText()
							.getForeground());
			distributorAddressText.setEditable(false);
			distributorAddressText.setText("Fill in the network address of "
					+ "the distributor (either an IP address or host name) "
					+ "and the port to connect to (default 55101):");
		}
		return distributorAddressText;
	}

	/**
	 * This method initializes distributorAddressText
	 * 
	 * @return javax.swing.JTextPane
	 */
	private JTextPane getSystemAddressesText() {
		if (systemAddressesText == null) {
			systemAddressesText = new JTextPane();
			systemAddressesText.setOpaque(false);
			systemAddressesText
					.setDisabledTextColor(getDistributorAddressText()
							.getForeground());
			systemAddressesText.setEditable(false);
			String addressTable = "";
			try {
				Enumeration<NetworkInterface> nins = NetworkInterface
						.getNetworkInterfaces();
				while (nins.hasMoreElements()) {
					NetworkInterface ni = nins.nextElement();
					if (!ni.isLoopback()) {
						Enumeration<InetAddress> adds = ni.getInetAddresses();
						while (adds.hasMoreElements()) {
							InetAddress add = adds.nextElement();
							addressTable += add.getHostAddress() + "\t"
									+ ni.getDisplayName() + "\n";
						}
					}
				}
			} catch (Exception e) {
			}
			systemAddressesText.setText("For reference, this machine has the "
					+ "following IP addresses:\n" + addressTable);
		}
		return systemAddressesText;
	}

	/**
	 * This method initializes distributorHostField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getDistributorHostField() {
		if (distributorHostField == null) {
			distributorHostField = new JTextField();
			distributorHostField.setText("192.168.1.");
		}
		return distributorHostField;
	}

	/**
	 * This method initializes distributorPortField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getDistributorPortField() {
		if (distributorPortField == null) {
			distributorPortField = new JTextField();
			distributorPortField.setText("55101");
		}
		return distributorPortField;
	}

	/**
	 * This method initializes distributorUserField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getDistributorUserField() {
		if (distributorUserField == null) {
			distributorUserField = new JTextField();
			distributorUserField.setText("node");
		}
		return distributorUserField;
	}

	/**
	 * This method initializes distributorPasswordField
	 * 
	 * @return javax.swing.JPasswordField
	 */
	private JPasswordField getDistributorPasswordField() {
		if (distributorPasswordField == null) {
			distributorPasswordField = new JPasswordField();
			distributorPasswordField.setText("password");
		}
		return distributorPasswordField;
	}

	/**
	 * This method initializes distributorLogonText
	 * 
	 * @return javax.swing.JTextPane
	 */
	private JTextPane getDistributorLogonText() {
		if (distributorLogonText == null) {
			distributorLogonText = new JTextPane();
			distributorLogonText.setOpaque(false);
			distributorLogonText.setDisabledTextColor(getDistributorLogonText()
					.getForeground());
			distributorLogonText.setEditable(false);
			distributorLogonText.setText("Enter the username and password "
					+ "for this node to use when registering with the "
					+ "distributor. You should have set this when configuring "
					+ "the distributor, it is the same for every node.");
		}
		return distributorLogonText;
	}

	private void updateSettings() {
		Settings set = Settings.instance();
		set.setStringProperty("connect.distributor.host",
				getDistributorHostField().getText());
		set.setStringProperty("connect.distributor.port",
				getDistributorPortField().getText());
		set.setStringProperty("connect.distributor.user",
				getDistributorUserField().getText());
		set.setStringProperty("connect.distributor.password", new String(
				getDistributorPasswordField().getPassword()));
	}

	@Override
	boolean validateForm() {
		String user = getDistributorUserField().getText();
		if (user.equals("")
				|| getDistributorPasswordField().getPassword().length == 0) {
			JOptionPane.showMessageDialog(this,
					"User name and password must be set.",
					"User/password not set", JOptionPane.WARNING_MESSAGE);
			return false;
		}
		if (!SafeString.isSafe(user)) {
			JOptionPane.showMessageDialog(WizardStep3.this,
					"The user name must be a valid and safe file name.",
					"Add User", JOptionPane.WARNING_MESSAGE);
			return false;
		}

		int port = -1;
		try {
			port = Integer.parseInt(getDistributorPortField().getText());
		} catch (Exception e) {
		}
		if (port < 1 || port > 65535) {
			JOptionPane.showMessageDialog(this,
					"Port must be a number between 1 and 65535.",
					"Invalid Port", JOptionPane.WARNING_MESSAGE);
			return false;
		}

		updateSettings();
		return true;
	}
}
