/*
 * Distriblend: A distributed rendering system for Blender
 * Copyright (C) 2007: Ian Philip Thompson
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 */

package net.sf.distriblend.share.net.event;

import net.sf.distriblend.share.net.Connector;

/**
 * Represents an event occuring on a connector to receptor connection.
 * 
 * @author Ian Thompson
 * 
 */
public class ConnectionEvent {

	/**
	 * @param source
	 */
	public ConnectionEvent(Connector source) {
		this.source = source;
	}

	/**
	 * Returns the <code>Connector</code> maintaining the connection that
	 * fired the event.
	 * 
	 * @return The <code>Connector</code> for the event's connection.
	 */
	public Connector getSource() {
		return source;
	}

	/* -- Private -- */

	private Connector source;
}
