/*
 * Distriblend: A distributed rendering system for Blender
 * Copyright (C) 2007: Ian Philip Thompson
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 */

/**
 * Contains shared protocols for communication between applications. Each
 * protocol uses a system of serialized objects which act as instructions or
 * contain the data required by the specific protocol.
 * <p>
 * The objects are immutable and, where appropriate, validate their fields upon
 * construction and again upon deserialization. This ensures objects that have
 * been tampered with remain valid. It does not <em>prevent</em> tampering and
 * code that makes use of these protocols must take this into account.
 */
package net.sf.distriblend.share.protocol;
